<template>
  <article id="app">
    <div class="content">
      <header id="galleryHeader">
        Welcome to <span class="highlighted">imagestock</span>
      </header>

      <div id="galleryItemsWrapper">
        <gallery-item-preview
          v-for="(image, index) in galleryCollection"
          :key="index"
          :image="image"
          :index="index"
          @openPopup="openPopup"
          @placeItems="setGalleryItemsPlacement"
        ></gallery-item-preview>

        <image-picker v-if="isUserAdmin"></image-picker>
      </div>

      <gallery-item-popup
        :isActive="isItemPopupActive"
        :imageId="popupImageId"
        @closePopup="closePopup"
      ></gallery-item-popup>

      <login-popup />
    </div>
  </article>
</template>

<script>
import { mapGetters } from "vuex";

import ImagePicker from "./components/ImgPicker.vue";
import GalleryItemPreview from "./components/GalleryItemPreview.vue";
import GalleryItemPopup from "./components/GalleryItemPopup.vue";
import LoginPopup from "./components/LoginPopup.vue";

export default {
  name: "gallery",
  components: {
    ImagePicker,
    GalleryItemPreview,
    GalleryItemPopup,
    LoginPopup,
  },
  data() {
    return {
      isItemPopupActive: false,
      popupImageId: 0,
    };
  },
  computed: { ...mapGetters(["galleryCollection", "isUserAdmin"]) },
  methods: {
    openPopup(id) {
      this.isItemPopupActive = true;
      this.popupImageId = id;
    },
    closePopup() {
      this.isItemPopupActive = false;
    },
    setGalleryItemsPlacement() {
      // eslint-disable-next-line no-undef
      new Packery("#galleryItemsWrapper", {
        itemSelector: ".gallery-item",
        gutter: 10,
        horizontal: true,
      });
    },
  },
  created() {
    this.$store.dispatch("bindImages");
  },
  mounted() {
    this.setGalleryItemsPlacement();
  },
  updated() {
    this.setGalleryItemsPlacement();
  },
};
</script>

<style lang="scss">
@import "assets/style/main.scss";

body {
  display: flex;
  height: 100vh;
}

#app {
  margin: auto;
  width: 100vw;
  height: 100vh;
  padding: 20px 20px;
  box-sizing: border-box;
  background: #f0f3f6;
}

#galleryItemsWrapper {
  height: inherit;
}

#galleryHeader {
  margin: 0 0 15px 5px;
  color: #8499a7;
  font: 800 24px Open Sans;
  text-align: center;
  text-transform: uppercase;

  .highlighted {
    color: $blue;
  }
}

.content {
  width: 100%;
  height: 100%;
  overflow-y: hidden;
  overflow-x: auto;
}

img {
  width: 100%;
  height: 100%;
}
</style>
